---
title: MediaStreamTrack.enabled
slug: Web/API/MediaStreamTrack/enabled
tags:
  - Media
  - Media Capture and Streams
  - MediaStreamTrack
  - Muting a Media Track
  - Muting a Track
  - Property
  - Reference
  - WebRTC
  - enabled
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p><span class="seoSummary">The <strong><code>enabled</code></strong> property on the {{domxref("MediaStreamTrack")}} interface is a Boolean value which is <code>true</code> if the track is allowed to render the source stream or <code>false</code> if it is not. This can be used to intentionally mute a track.</span> When enabled, a track's data is output from the source to the destination; otherwise, empty frames are output.</p>

<p>In the case of audio, a disabled track generates frames of silence (that is, frames in which every sample's value is 0). For video tracks, every frame is filled entirely with black pixels.</p>

<p>The value of <code>enabled</code>, in essence, represents what a typical user would consider the muting state for a track, whereas the {{domxref("MediaStreamTrack.muted", "muted")}} property indicates a state in which the track is temporarily unable to output data, such as a scenario in which frames have been lost in transit.</p>

<div class="note">
<p><strong>Note:</strong> If the track has been disconnected, the value of this property can be changed, but has no effect.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">const <em>enabledFlag</em> = <em>track</em>.enabled
<em>track</em>.enabled = [true | false]</pre>

<h3 id="Value">Value</h3>

<p>When <code>true</code>, <code>enabled</code> indicates that the track is permitted to render its actual media to the output. When <code>enabled</code> is set to <code>false</code>, the track only generates empty frames.</p>

<p>Empty audio frames have every sample's value set to 0. Empty video frames have every pixel set to black.</p>

<div class="note">
<p><strong>Note:</strong> When implementing a mute/unmute feature, you should use the <code>enabled</code> property.</p>
</div>

<h2 id="Usage_notes">Usage notes</h2>

<p>If the {{domxref("MediaStreamTrack")}} represents the video input from a camera, disabling the track by setting <code>enabled</code> to <code>false</code> also updates device activity indicators to show that the camera is not currently recording or streaming. For example, the green "in use" light next to the camera in iMac and MacBook computers turns off while the track is muted in this way.</p>

<h2 id="Example">Example</h2>

<p>This example demonstrates a {{event("click")}} event handler for a pause button.</p>

<pre class="brush: js">pauseButton.onclick = function(evt) {
  const newState = !myAudioTrack.enabled;

  pauseButton.innerHTML = newState ? "&amp;#x25B6;&amp;#xFE0F;" : "&amp;#x23F8;&amp;#xFE0F;";
  myAudioTrack.enabled = newState;
}</pre>

<p>This creates a variable, <code>newState</code>, which is the opposite of the current value of <code>enabled</code>, then uses that to select either the Emoji character for the "play" icon or the character for the "pause" icon as the new {{domxref("Element.innerHTML", "innerHTML")}} of the pause button's element.</p>

<p>Finally, the new value of <code>enabled</code> is saved, making the change take effect.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('Media Capture', '#dom-mediastreamtrack-enabled', 'enabled') }}</td>
   <td>{{ Spec2('Media Capture') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaStreamTrack.enabled")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API">MediaStream API</a></li>
 <li>{{domxref("MediaStream")}}</li>
 <li>{{domxref("MediaStreamTrack")}}</li>
 <li><a href="/en-US/docs/Web/Guide/API/WebRTC">WebRTC</a></li>
</ul>
